// Copyright (C) 2003 by Robert C. Martin and Micah D. Martin. All rights reserved.
// Released under the terms of the GNU General Public License version 2 or later.
package fitnesse2.http;



public class MockResponseSender implements ResponseSender

{

	private StringBuffer buffer = new StringBuffer();

	public boolean closed = false;



	public MockResponseSender()

	{

	}



	public MockResponseSender(Response response) throws Exception

	{

		doSending(response);

	}



	public void send(byte[] bytes) throws Exception

	{

		buffer.append(new String(bytes));

	}



	public void close() throws Exception

	{

		closed = true;

	}



	public String sentData()

	{

		return buffer.toString();

	}



	public void doSending(Response response) throws Exception

	{

		response.readyToSend(this);

		while(!closed)

			Thread.sleep(1);

	}

}

