// Copyright (C) 2003 by Robert C. Martin and Micah D. Martin. All rights reserved.
// Released under the terms of the GNU General Public License version 2 or later.
package fitnesse2.responders;

import fitnesse2.Responder;
import fitnesse2.testutil.RegexTest;
import fitnesse2.http.*;
import junit.swingui.TestRunner;

public class ErrorResponderTest extends RegexTest
{
	public static void main(String[] args)
	{
		TestRunner.main(new String[]{"ErrorResponderTest"});
	}

	public void testResponse() throws Exception
	{
		MockHttpRequest request = new MockHttpRequest();
		request.setResource("/blah");

		Responder responder = new ErrorResponder(new Exception("some error message"));
		Response response = responder.makeResponse(new MockHttpRequest());

		assertEquals(400, response.getStatus());

		String body = response.getContent();

		assertHasRegexp("<html>", body);
		assertHasRegexp("<body", body);
		assertHasRegexp("java.lang.Exception: some error message", body);
	}
}
