package fitnesse2.responders;

import fitnesse2.Responder;
import fitnesse2.http.MockHttpRequest;
import xpcinci.responders.*;
import junit.framework.TestCase;

public class ResponderFactoryTest extends TestCase
{
	private ResponderFactory factory;
	private MockHttpRequest request;

	public void setUp() throws Exception
	{
		factory = new ResponderFactory(".");
		request = new MockHttpRequest();
	}
	
	public void testNotFound() {
		request.setResource("NotECal");
		assertResponderType(NotFoundResponder.class);		
	}

	public void testDisplay() {
		request.setResource("ECal");
		request.addInput("cmd","display");
		assertResponderType(DisplayResponder.class);		
	}

	public void testNonCommand() {
		request.setResource("ECal");
		request.addInput("notacommand","exit");
		assertResponderType(FrontPageResponder.class);		
	}

	public void testErrorResponder() throws Exception
	{
		request.throwExceptionOnParse(new Exception("some exception"));
		assertResponderType(NotFoundResponder.class);
	}


	private void assertResponderType(Class expectedClass)
	{
		Responder responder = factory.makeResponder(request);
		assertEquals(expectedClass, responder.getClass());
	}
}
