// Copyright (C) 2003 by Robert C. Martin and Micah D. Martin. All rights reserved.
// Released under the terms of the GNU General Public License version 2 or later.
package fitnesse2.responders.html;

import java.util.*;

public class HtmlPage extends HtmlElement
{
	private String htmlTitle = "ECal";
	private String bgColor = "#FFFFFF";
	private String onload = null;

	private List elements = new ArrayList();

	public String html() throws Exception
	{
		StringBuffer html = new StringBuffer();
		html.append(pageHeader());
		html.append(pageBody());
		html.append(pageFooter());
		return html.toString();
	}

	public String pageBody() throws Exception
	{
		StringBuffer html = new StringBuffer();
		for(Iterator iterator = elements.iterator(); iterator.hasNext();)
		{
			HtmlElement element = (HtmlElement) iterator.next();
			html.append(element.html());
		}

		return html.toString();
	}

	public String pageHeader()
	{
		StringBuffer buffer = new StringBuffer();
		buffer.append("<html>").append(endl);
		buffer.append("<head><title>").append(htmlTitle).append("</title></head>").append(endl);
		buffer.append("<body").append(" bgcolor=\"").append(bgColor).append("\" link=\"#E72021\" vlink=\"#7B2C31\"");
		if(onload != null)
			buffer.append(" onload=\"").append(onload).append("\"");
		buffer.append(">").append(endl);
		return buffer.toString();
	}

	public String pageFooter()
	{
		StringBuffer buffer = new StringBuffer();
		buffer.append("</body>").append(endl);
		buffer.append("</html>");
		return buffer.toString();
	}

	public void setHtmlTitle(String title)
	{
		htmlTitle = title;
	}

	public void addElement(HtmlElement element)
	{
		elements.add(element);
	}

	public void addContent(String content)
	{
		elements.add(new RawHtml(content));
	}

	public void setBackgroundColor(String color)
	{
		bgColor = color;
	}

	public void setOnload(String onload)
	{
		this.onload = onload;
	}
}