// Copyright (C) 2003 by Robert C. Martin and Micah D. Martin. All rights reserved.
// Released under the terms of the GNU General Public License version 2 or later.
package fitnesse2.responders.html;

import fitnesse2.testutil.RegexTest;

public class HtmlPageTest extends RegexTest
{
	private HtmlPage page;

	public void setUp() throws Exception
	{
		page = new HtmlPage();
	}

	public void tearDown() throws Exception
	{
	}

	public void testBasics() throws Exception
	{
		String html = page.html();
		assertTrue(html.startsWith("<html>"));
		assertHasRegexp("<body", html);
		assertHasRegexp("</body>", html);
		assertTrue(html.endsWith("</html>"));
	}

	public void testHtmlTitle() throws Exception
	{
		page.setHtmlTitle("Kowabunga");
		String html = page.html();
		assertHasRegexp("<title>Kowabunga</title>", html);
	}

	public void testContent() throws Exception
	{
		page.addContent("head, torso, arms and legs");
		String html = page.html();
		assertHasRegexp("head, torso, arms and legs", html);
	}

	public void testBackgroundColor() throws Exception
	{
		page.setBackgroundColor("#ABCDEF");
		String html = page.html();
		assertHasRegexp("<body bgcolor=\"#ABCDEF\"", html);
	}

	public void testAddElement() throws Exception
	{
		page.addElement(new RawHtml("stuff"));
		assertSubString("stuff", page.html());
	}
}