// Copyright (C) 2003 by Robert C. Martin and Micah D. Martin. All rights reserved.
// Released under the terms of the GNU General Public License version 2 or later.
package fitnesse2.testutil;

import java.io.*;
import java.net.*;

public class MockSocket extends Socket
{
	InputStream input;
	OutputStream output;
	private String host;

	public MockSocket(String input)
	{
		this.input = new ByteArrayInputStream(input.getBytes());
		output = new ByteArrayOutputStream();
	}

	public InputStream getInputStream()
	{
		return input;
	}

	public OutputStream getOutputStream()
	{
		return output;
	}

	public void close()
	{
		try
		{
			input.close();
			output.close();
		}
		catch(IOException e)
		{
			e.printStackTrace();
		}
	}

	public String getOutput()
	{
		return output.toString();
	}

	public void setHost(String host)
	{
		this.host = host;
	}

	public SocketAddress getRemoteSocketAddress()
	{
		return new InetSocketAddress(host, 123);
	}
}
