package ft.domain;
import java.text.*;
import java.util.*;

import xpcinci.domain.*;
import xpcinci.time.*;

import fit.ActionFixture;
import ft.web.ECalWebClient;

public class ECalAction extends ActionFixture {

	public void start() throws Exception {
		super.start();
	}

	public String groupsTop() {
		return ECalWebClient.cal().groupsTop();
	}

	public int countOfEvents() {
		return ECalWebClient.cal().countOfEvents();
	}

	public int countOfGroups() {
		return ECalWebClient.cal().countOfGroups();
	}

	public void week(Week week) {
		ECalWebClient.cal().eventsForWeek(week);
	}

//	public void query(TEScript when) {
//		ECalWebClient.cal().queryScript(when);
//	}

	public String header() {
		return "";
	}
	public String title() {
		return "";
	}

	public Object parse(String string, Class type) throws Exception {
		// double dispatch to connect 'to' and 'from' types
		if (type.equals(Date.class)) {
			return parseDate(string);
		}
		if (type.equals(Week.class)) {
			return new Week(string);
		}
		if (type.equals(TEScript.class)) {
			TEScript s = new TEScript("(" + string + ")");
			return s;
		}
		return super.parse(string, type);
	}

	// =================================== 
	//  parse Date
	// 
	private static DateFormat dateFormat = new SimpleDateFormat("ddMMMyyyy");

	public static Object parseDate(String dateString) throws Exception {
		if (hasNoDay(dateString)) {
			return parseWholeMonth(dateString);
		}
		return dateFormat.parse(dateString);
	}

	private static Object parseWholeMonth(String dateString)
		throws ParseException {
		dateString = "01" + dateString;
		return dateFormat.parse(dateString);
	}
	private static boolean hasNoDay(String string) {
		return !Character.isDigit(string.charAt(0));
	}

}
