package ft.domain;
import java.util.Date;

import xpcinci.domain.util.*;
import xpcinci.time.*;
import fit.ColumnFixture;

public class EventBuild extends ColumnFixture {
	public EventBuild() {
		super();
	}

	public String name;
	public String group;
	public TEScript when;

	public boolean created() {
		notNull(name, "name");
		notNull(group, "group");
		notNull(when, "when");
		notNull(ECalSingleton.schedule(), "cal");

		int before = ECalSingleton.schedule().countOfEvents();
		ECalSingleton.schedule().createEvent(name, group, when);
		int after = ECalSingleton.schedule().countOfEvents();

		name = group = null;
		when = null;
		return (before + 1 == after);
	}

	private void notNull(Object obj, String name) {
		if (obj == null)
			throw new RuntimeException(name + " cannot be null");
	}

	public Object parse(String string, Class type) throws Exception {
		// double dispatch to connect 'to' and 'from' types
		if (type.equals(Date.class)) {
			return DateParser.parse(string);
		}
		if (type.equals(TEScript.class)) {
			TEScript s = new TEScript("(" + string + ")");
			return s;
		}

		return super.parse(string, type);
	}

}
