package ft.domain;

import xpcinci.domain.*;
import xpcinci.time.*;
import junit.framework.*;

public class EventBuildTest extends TestCase {

	public EventBuildTest(String arg0) {
		super(arg0);
	}

	public static void main(String[] args) {
		junit.swingui.TestRunner.run(EventBuildTest.class);
	}
	EventBuild ebuild;

	protected void setUp() throws Exception {
		super.setUp();
		ECalSingleton.reset();
		ebuild = new EventBuild();
		TEScript s = new TEScript("(time (year 2004)(month 01)(daynum 04))");
		ebuild.when = s;
		ebuild.name = "testevent";
		ebuild.group = "testgroup";
		ebuild.created();
	}

	protected void tearDown() throws Exception {
		super.tearDown();
		ECalSingleton.reset();
	}

	public void testCreateOne() {
		assertEquals(1, ECalSingleton.schedule().countOfEvents());
		assertEquals(1, ECalSingleton.schedule().countOfGroups());
	}

	public void testIsOnDate() {
		ScheduleElement all[] = ECalSingleton.schedule().allEvents();
		ScheduleElement first = all[0];
		assertNotNull("first event is null", first);
		assertTrue(first.occursOn(new Day(2004,01,04)));
		assertFalse(first.occursOn(new Day(2001,01,01)));
	}

	public void testFixturePage() {
		ECalSingleton.reset();
		ebuild = new EventBuild();
		TEScript s = new TEScript("(time (year 2004)(month 01)(daynum 04))");
		ebuild.when = s;
		ebuild.name = "testevent";
		ebuild.group = "testgroup";
		ebuild.created();
		ECalAction action = new ECalAction();
		action.week(new Week("2004,02"));
		
		ScheduleElementAllRows display = new ScheduleElementAllRows();
		ScheduleElement results[] = (ScheduleElement[])display.query(); 
		assertEquals(1,results.length);
		ScheduleElement one = results[0];
		assertEquals("testevent", one.name()); 				
		assertEquals("testevent", one.name);
		assertEquals("testgroup", one.groupName());
		assertEquals("testevent", one.toString());
		assertTrue(one.occursOn(new Day(2004,01,04))); 
		
	}

}
