package xpcinci.responders;

import java.util.Map;

import fitnesse2.http.MockHttpRequest;
import fitnesse2.http.SimpleResponse;
import fitnesse2.testutil.RegexTest;
import xpcinci.domain.*;

public class DayResponderTest extends RegexTest {
	private MockHttpRequest request;
	DayResponder command;

	public void setUp() {
		request = new MockHttpRequest();
		command = new DayResponder();
	}

	public void testMakeResponse() throws Exception {
		DayResponder res = new DayResponder_underTest();
		MockHttpRequest request = new MockHttpRequest();
		request.addInput(ARGS.CURRENT, "20040105");
		res.makeResponse(request);
		assertEquals("runTemplate", methods);
		assertTrue(actual_map.containsKey(ARGS.PAGEDATE));
		assertTrue("has a day", actual_map.containsKey("day"));
		assertEquals("day", actual_name);
	}

	public void testProcess() throws Exception {
		DayResponder res = new DayResponder();
		MockHttpRequest request = new MockHttpRequest();
		request.addInput(ARGS.CURRENT, "20040105");
		Day actual = res.process(request);
		assertEquals("01Jan2004", actual.toString());
	}

	// ============================= under test
	String methods = "";
	Map actual_map;
	String actual_name = "";

	class DayResponder_underTest extends DayResponder {
		protected SimpleResponse runTemplate(String name, Map map) {
			actual_name = name;
			actual_map = map;
			methods += "runTemplate";
			return new SimpleResponse();
		}
	}

}
