package xpcinci.responders;

import java.util.*;

import fitnesse2.http.*;
import fitnesse2.testutil.*;

public class DisplayResponderTest extends RegexTest
{
	private MockHttpRequest request;	
	DisplayResponder command;

	public void setUp()
	{
		request = new MockHttpRequest();
		command = new DisplayResponder();
	}
	
	
	public void testMakeResponse() throws Exception {
		DisplayResponder res = new DisplayResponder_underTest();
		MockHttpRequest request = new MockHttpRequest();
		request.addInput(ARGS.CURRENT,"20040101");
		res.makeResponse(request);
		assertEquals("runTemplate", methods);
		assertTrue(actual_map.containsKey(ARGS.PAGEDATE));
		assertTrue(actual_map.containsKey("calendar"));
		assertEquals("display", actual_name);
	}

	public void testProcess() throws Exception {
		DisplayResponder res = new DisplayResponder();
		MockHttpRequest request = new MockHttpRequest();
		request.addInput(ARGS.CURRENT,"20040101");
		res.process(request);
		assertEquals("200402",res.result.get(RESULTS.PLUSONE));
		assertEquals("200405",res.result.get(RESULTS.PLUSFOUR));
		assertEquals("200352",res.result.get(RESULTS.MINUSONE));
		assertEquals("200349",res.result.get(RESULTS.MINUSFOUR));
	}

	
	// ============================= under test
	String methods = "";
	Map actual_map;
	String actual_name = "";

	class DisplayResponder_underTest extends DisplayResponder {
		protected SimpleResponse runTemplate(String name, Map map) {
			actual_name = name;
			actual_map = map;
			methods += "runTemplate";
			return new SimpleResponse();
		}
	}
	
}
