// Copyright (C) 2003 by Robert C. Martin and Micah D. Martin. All rights reserved.
// Released under the terms of the GNU General Public License version 2 or later.
package xpcinci.responders;

import fitnesse2.Responder;
import fitnesse2.testutil.RegexTest;
import fitnesse2.http.*;
import junit.swingui.TestRunner;

public class NotFoundResponderTest extends RegexTest
{
	public static void main(String[] args)
	{
		TestRunner.main(new String[]{"NotFoundResponderTest"});
	}

	public void setUp() throws Exception
	{
	}

	public void tearDown() throws Exception
	{
	}

	public void testResponse() throws Exception
	{
		MockHttpRequest request = new MockHttpRequest();
		request.setResource("some page");

		Responder responder = new NotFoundResponder();
		Response response = responder.makeResponse( request);

		assertEquals(404, response.getStatus());

		String body = response.getContent();

		assertHasRegexp("<html>", body);
		assertHasRegexp("<body", body);
		assertHasRegexp("some page", body);
		assertHasRegexp("Not Found", body);
	}

}
