// Purpose:
//
package xpcinci.template;

import java.io.InputStream;
import java.util.Properties;

public class Environment {

	public static String applPath() {
		return new Environment().getApplPath(); 
	}
	
	public String getApplPath()
	{
		return getProperty("appl.path");
	}

	private Properties getProperties() {
		InputStream input = loadResource();
		Properties properties = new Properties();
		try {
			properties.load(input);
		} catch (Exception ex) {
			throw new RuntimeException(
				"Can't Find: classes/ecal.properties",
				ex);
		}
		return properties;
	}

	protected InputStream loadResource() {
		return Environment.class.getResourceAsStream("/ecal.properties");
	}

	String getProperty(String propname) {
		Properties prop = getProperties();
		if (!prop.containsKey(propname))
			throw new RuntimeException(
				"Environment() property not found: " + propname);
		return prop.getProperty(propname);
	}
}
