package xpcinci.template;

import java.io.*;
import java.util.*;

public class Template {

	File templateFile;
	Map map;
	String raw;
	String filtered = "";
	final static String sep = System.getProperty("file.separator");
	static private String path;

	public Template() {
	}

	public Template(String fileName, Map map) throws IOException {
		filtered = run(fileName, map);
	}

	public String run(String fileName, Map map) {
		this.map = map;
		loadTemplate(fileName);

		try {
			read();
			run();
		} catch (IOException e) {
			return handleException(fileName,e);
		}
		return filtered;
	}

	public File loadTemplate(String fileName) {
		templateFile = new File(path() + sep + "template" + sep + fileName);
		return templateFile;
	}

	public String path() {
		if (path != null)
			return path;
		path = Environment.applPath();
		return path;
	}

	String handleException(String fileName,Exception e) {
		return defaultHtml(fileName);
	}

	static String defaultHtml(String filename) {
		Map map = new HashMap();
		map.put("filename", filename);
		return prepare(defaultHtml, map);
	}

	private static String prepare(String raw, Map map) {
		StringWriter sw = new StringWriter();
		PrintWriter pw = new PrintWriter(sw);
		new FastToken(raw, pw, map);
		return sw.toString();
	}

	void run() throws IOException {
		filtered = prepare(raw, map);
	}

	void read() throws IOException {
		char chars[] = new char[(int) (templateFile.length())];
		FileReader in;
		in = new FileReader(templateFile);
		in.read(chars);
		in.close();
		raw = new String(chars);
	}

	final static String defaultHtml =
		"<html> <head> <title>Event Calander: File Error</title></head>"
			+ "<h2>Event Calander: File Error</h2>"
			+ "File:<b><%filename%></b> Not Found. <br>"
			+ "classes/ecal.properties file should contain path to root of application"
			+ "</body></html>";

}
