package xpcinci.time;

import java.util.*;

import xpcinci.domain.*;

public class TEDay extends TimeExpression {
	private Day day;

	public boolean occursOn(Day query) {
		return day.equals(query);
	}

	public Day singleDay() {
		return day;
	}

	public void setDate(Day day) {
		this.day = day;
	}

	public static int understandsContent(List list) {

		if (list.contains(TE.YYYYMMDD))
			return 1;

		int howfit = 0;
		if (list.contains(TE.YEAR))
			howfit++;
		if (list.contains(TE.MONTH))
			howfit++;
		if (list.contains(TE.DAYNUM))
			howfit++;
		return (howfit == 3) ? 3 : 0;
	}

	public static TEDay create(TEScript script) {
		if (!script.keyword.equals(TE.TIME))
			throw new RuntimeException(
				"TEDayInWeek.create() requires '" + TE.TIME + "' keyword.");
		int format;
		if (0 == (format = understandsContent(script.contentNames())))
			return null;
		script = script.child;

		Day day;
		if (format == 1)
			day = shortFormat(script);
		else
			day = longFormat(script);
		TEDay result = new TEDay();
		result.setDate(day);
		return result;
	}

	private static Day longFormat(TEScript script) {
		Day day =
			new Day(
				script.getInt(TE.YEAR),
				script.getInt(TE.MONTH),
				script.getInt(TE.DAYNUM));
		return day;
	}

	private static Day shortFormat(TEScript script) {
		Day day = new Day(script.getInt(TE.YYYYMMDD));
		return day;
	}
}
