package xpcinci.time;

import junit.framework.*;

public class TEFactoryTest extends TestCase {

	public void testTEDay() {
		TEScript script = new TEScript("(time (yyyymmdd 20011212))");
		TimeExpression te = TEFactory.timeExpressionFrom(script);
		assertEquals(TEDay.class, te.getClass());
	}

	public void testTEDayInWeek() {
		TEScript script = new TEScript("(time (dow 5))");
		TimeExpression te = TEFactory.timeExpressionFrom(script);
		assertEquals(TEDayInWeek.class, te.getClass());
	}



	public void testInvalid() {
		TEScript script = new TEScript("(time (weeknum 33))");
		try {
			TimeExpression te = TEFactory.timeExpressionFrom(script);
		} catch (Exception x) {
			assertEquals(NotYetImplementedException.class, x.getClass());
			return;
		}
		fail("Should throw NotYetImplementedException");
	}

}